## hubzero-submit-monitors 3.6.4-1+deb7

=== Makefile ===
# @package      hubzero-submit-monitors
# @file         Makefile
# @copyright    Copyright (c) 2010-2020 The Regents of the University of California.
# @license      http://opensource.org/licenses/MIT MIT
#
# Copyright (c) 2010-2020 The Regents of the University of California.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# HUBzero is a registered trademark of The Regents of the University of California.
#

DISTRIBUTION := $(shell lsb_release -i -s)
MAJORVERSION := $(shell lsb_release -rs | cut -d . -f 1)

ifeq ($(DISTRIBUTION),Debian)
il=--install-layout=deb
endif

BATCHMONITORS = monitorBOINC.py monitorCondor.py monitorCondorG.py monitorFactory.py monitorLL.py \
                monitorLSF.py monitorPBS.py monitorSGE.py monitorSLURM.py monitorWF.py
MONITORJOBS = monitorJob.py monitorJobSite.py monitorJobSQL.py monitorJobSiteSQL.py \
              jobCacheSimTools.py jobExecuter.py jobMetrics.py jobProcessor.py jobStageInput.py
MONITORJOBUTILS = monitorJobA.py monitorJobP.py monitorJobQ.py monitorJobR.py \
                  monitorJobS.py monitorJobT.py monitorJobU.py
MONITORTUNNEL = monitorTunnel.py
MONITORTUNNELUTILS = monitorTunnelA.py monitorTunnelD.py monitorTunnelI.py monitorTunnelR.py monitorTunnelT.py
MONITORPROBE = monitorProbe.py
MONITORPROBEUTILS = monitorProbeD.py monitorProbeQ.py monitorProbeR.py monitorProbeU.py
MANAGEIDENTITIES = manageIdentities.py
MANAGEIDENTITYUTILS = manageIdentitiesQ.py
IDENTITYMANAGERSCRIPTS = generate-grid-proxy.sh generate-voms-proxy.sh \
                         genuserid.sh genuserpki.sh \
                         personalize-copy-proxy.sh personalize-saml-proxy.sh \
                         refresh-condor-proxy.sh refresh-jobmon-proxy.sh \
                         refresh-oauth-token.sh writecommunitysecret.sh
SERVICEMONITORS = start status stop
SUBMITDIR=$(DESTDIR)/opt/submit
VARLOGDIR=$(DESTDIR)/var/log
VARGRIDMAN=$(DESTDIR)/var/gridman
ETCDIR=$(DESTDIR)/etc

all:
	@true

install:
	# create-optsubmit
	install --mode 0755 -d $(SUBMITDIR)
	# install-batchmonitors
	install --mode 2750 -d $(SUBMITDIR)/BatchMonitors
	for batchMonitor in $(BATCHMONITORS) ; do \
		install --mode 0750 -D BatchMonitors/$${batchMonitor} $(SUBMITDIR)/BatchMonitors/$${batchMonitor}; \
	done
	# install-monitor-job
	for monitorJob in $(MONITORJOBS) ; do \
		install --mode 0750 -D $${monitorJob} $(SUBMITDIR)/$${monitorJob}; \
	done
	for monitorJobUtil in $(MONITORJOBUTILS) ; do \
		install --mode 0750 -D $${monitorJobUtil} $(SUBMITDIR)/$${monitorJobUtil}; \
	done
	# install-monitor-tunnel
	install --mode 0750 -D $(MONITORTUNNEL) $(SUBMITDIR)/$(MONITORTUNNEL); \
	for monitorTunnelUtil in $(MONITORTUNNELUTILS) ; do \
		install --mode 0750 -D $${monitorTunnelUtil} $(SUBMITDIR)/$${monitorTunnelUtil}; \
	done
	# install-monitor-probe
	install --mode 0750 -D $(MONITORPROBE) $(SUBMITDIR)/$(MONITORPROBE); \
	for monitorProbeUtil in $(MONITORPROBEUTILS) ; do \
		install --mode 0750 -D $${monitorProbeUtil} $(SUBMITDIR)/$${monitorProbeUtil}; \
	done
	# install-manage-identities
	install --mode 0750 -D $(MANAGEIDENTITIES) $(SUBMITDIR)/$(MANAGEIDENTITIES); \
	for manageIdentityUtil in $(MANAGEIDENTITYUTILS) ; do \
		install --mode 0750 -D $${manageIdentityUtil} $(SUBMITDIR)/$${manageIdentityUtil}; \
	done
	for identityManagerScript in $(IDENTITYMANAGERSCRIPTS) ; do \
		install --mode 0755 -D bin/$${identityManagerScript} $(VARGRIDMAN)/bin/$${identityManagerScript}; \
	done
	# initialize-monitor-job
	install --mode 0750 -D monitorJobInitialize.py $(SUBMITDIR)/monitorJobInitialize.py
	install --mode 0750 -D monitorJobInitialize.sh $(SUBMITDIR)/monitorJobInitialize.sh
	# install-process-monitors
	for serviceMonitor in $(SERVICEMONITORS) ; do \
		install --mode 0750 -D $${serviceMonitor} $(SUBMITDIR)/$${serviceMonitor}; \
	done
	# install-monitor-logs
	install --mode 0775 -d $(VARLOGDIR)/submit
	install --mode 0755 -d $(VARLOGDIR)/submit/monitors
	# install-server-init
	[ -f $(ETCDIR)/submit/jobmonitors.conf ] || install --mode 0644 -D jobmonitor.conf_dft $(ETCDIR)/submit/jobmonitor.conf
	install --mode 0755 -D identityman $(ETCDIR)/init.d/identityman
	install --mode 0755 -D jobcachesimtools $(ETCDIR)/init.d/jobcachesimtools
	install --mode 0755 -D jobexe $(ETCDIR)/init.d/jobexe
	install --mode 0755 -D jobmetrics $(ETCDIR)/init.d/jobmetrics 
	install --mode 0755 -D jobmon $(ETCDIR)/init.d/jobmon  
	install --mode 0755 -D jobpro $(ETCDIR)/init.d/jobpro
	install --mode 0755 -D jobstageinput $(ETCDIR)/init.d/jobstageinput
	install --mode 0755 -D tunnelmon $(ETCDIR)/init.d/tunnelmon 
	install --mode 0755 -D probemon $(ETCDIR)/init.d/probemon 
	python3 setup.py install $(COMPILE) --root $(DESTDIR) $(il)

uninstall:
	@true

postinst:
	# install-user-gridman
	adduser --quiet --system --group --force-badname --home /var/gridman --shell /bin/bash --disabled-password --gecos Gridman gridman || true
	adduser --quiet gridman tunneler || true
	# install-monitor-job
	chgrp gridman $(SUBMITDIR)/monitorJobInitialize.py
	chgrp gridman $(SUBMITDIR)/monitorJobInitialize.sh
	for monitorJob in $(MONITORJOBS) ; do \
		chgrp gridman $(SUBMITDIR)/$(monitorJob); \
	done
	for monitorJobUtil in $(MONITORJOBUTILS) ; do \
		chgrp gridman $(SUBMITDIR)/$(monitorJobUtil); \
	done
	chown gridman:gridman $(ETCDIR)/submit/jobmonitor.conf
	# install-monitor-tunnel
	chgrp gridman $(SUBMITDIR)/$(MONITORTUNNEL)
	for monitorTunnelUtil in $(MONITORTUNNELUTILS) ; do \
		chgrp gridman $(SUBMITDIR)/$(monitorTunnelUtil); \
	done
	# install-monitor-probe
	chgrp gridman $(SUBMITDIR)/$(MONITORPROBE)
	for monitorProbeUtil in $(MONITORPROBEUTILS) ; do \
		chgrp gridman $(SUBMITDIR)/$(monitorProbeUtil); \
	done
	# install-manage-identities
	chgrp gridman $(SUBMITDIR)/$(MANAGEIDENTITIES)
	for manageIdentityUtil in $(MANAGEIDENTITYUTILS) ; do \
		chgrp gridman $(SUBMITDIR)/$(manageIdentityUtil); \
	done
	# install-process-monitors
	for serviceMonitor in $(SERVICEMONITORS) ; do \
		chgrp gridman $(SUBMITDIR)/$(serviceMonitor); \
	done
	# install-monitor-logs
	if [ ! -d ${VARLOG}/submit ] ; \
	then \
		mkdir --mode=0775 ${VARLOG}/submit ; \
	fi
	if [ ! -d ${VARLOG}/submit/monitors ] ; \
	then \
		mkdir --mode=0755 ${VARLOG}/submit/monitors ; \
		chown gridman ${VARLOG}/submit/monitors ; \
	fi
	if [ ! -f ${VARLOG}/submit/monitors/monitorJob.log ] ; \
	then \
		touch ${VARLOG}/submit/monitors/monitorJob.log ; \
		chmod 0644 ${VARLOG}/submit/monitors/monitorJob.log ; \
		chown gridman:gridman ${VARLOG}/submit/monitors/monitorJob.log ; \
	fi
	if [ ! -f ${VARLOG}/submit/monitors/monitorJobSite.log ] ; \
	then \
		touch ${VARLOG}/submit/monitors/monitorJobSite.log ; \
		chmod 0644 ${VARLOG}/submit/monitors/monitorJobSite.log ; \
		chown gridman:gridman ${VARLOG}/submit/monitors/monitorJobSite.log ; \
	fi
	if [ ! -f ${VARLOG}/submit/monitors/monitorJobSQL.log ] ; \
	then \
		touch ${VARLOG}/submit/monitors/monitorJobSQL.log ; \
		chmod 0644 ${VARLOG}/submit/monitors/monitorJobSQL.log ; \
		chown gridman:gridman ${VARLOG}/submit/monitors/monitorJobSQL.log ; \
	fi
	if [ ! -f ${VARLOG}/submit/monitors/monitorJobSiteSQL.log ] ; \
	then \
		touch ${VARLOG}/submit/monitors/monitorJobSiteSQL.log ; \
		chmod 0644 ${VARLOG}/submit/monitors/monitorJobSiteSQL.log ; \
		chown gridman:gridman ${VARLOG}/submit/monitors/monitorJobSiteSQL.log ; \
	fi
	if [ ! -f ${VARLOG}/submit/monitors/jobCacheSimTools.log ] ; \
	then \
		touch ${VARLOG}/submit/monitors/jobCacheSimTools.log ; \
		chmod 0644 ${VARLOG}/submit/monitors/jobCacheSimTools.log ; \
		chown gridman:gridman ${VARLOG}/submit/monitors/jobCacheSimTools.log ; \
	fi
	if [ ! -f ${VARLOG}/submit/monitors/jobExecuter.log ] ; \
	then \
		touch ${VARLOG}/submit/monitors/jobExecuter.log ; \
		chmod 0644 ${VARLOG}/submit/monitors/jobExecuter.log ; \
		chown gridman:gridman ${VARLOG}/submit/monitors/jobExecuter.log ; \
	fi
	if [ ! -f ${VARLOG}/submit/monitors/jobMetrics.log ] ; \
	then \
		touch ${VARLOG}/submit/monitors/jobMetrics.log ; \
		chmod 0644 ${VARLOG}/submit/monitors/jobMetrics.log ; \
		chown gridman:gridman ${VARLOG}/submit/monitors/jobMetrics.log ; \
	fi
	if [ ! -f ${VARLOG}/submit/monitors/jobProcessor.log ] ; \
	then \
		touch ${VARLOG}/submit/monitors/jobProcessor.log ; \
		chmod 0644 ${VARLOG}/submit/monitors/jobProcessor.log ; \
		chown gridman:gridman ${VARLOG}/submit/monitors/jobProcessor.log ; \
	fi
	if [ ! -f ${VARLOG}/submit/monitors/jobStageInput.log ] ; \
	then \
		touch ${VARLOG}/submit/monitors/jobStageInput.log ; \
		chmod 0644 ${VARLOG}/submit/monitors/jobStageInput.log ; \
		chown gridman:gridman ${VARLOG}/submit/monitors/jobStageInput.log ; \
	fi

	if [ ! -f ${VARLOG}/submit/monitors/monitorTunnel.log ] ; \
	then \
		touch ${VARLOG}/submit/monitors/monitorTunnel.log ; \
		chmod 0644 ${VARLOG}/submit/monitors/monitorTunnel.log ; \
		chown gridman:gridman ${VARLOG}/submit/monitors/monitorTunnel.log ; \
	fi

	# initialize-monitor-job:
	$(SUBMITDIR)/monitorJobInitialize.sh

	# install-server-init
	insserv probemon
	insserv identityman
	insserv jobcachesimtools
	insserv jobexe
	insserv jobmetrics 
	insserv jobmon  
	insserv jobpro
	insserv jobstageinput
	insserv tunnelmon
	insserv

clean:
	find . -name '*.pyc' -delete
	rm -f build-stamp
	rm -f configure-stamp
	python setup.py clean
	rm -fr build

.PHONY: all install uninstall postinst clean

=== debian/changelog ===
hubzero-submit-monitors (3.6.4-1+deb7) unstable; urgency=low

    Update to version 3.6.4
    Added scripts for starting/stopping/reporting services status
    Switch to default sqlite job database

 -- Steven Clark <smclark@ucsd.edu>  Fri, 09 Jun 2023 07:51:22 -0700

hubzero-submit-monitors (3.6.3-1) unstable; urgency=low

    - Upgrade to 3.6.3

 -- Steven Clark <smclark@ucsd.edu>  Tue, 16 May 2023 15:45:56 -0700

## hubzero-submit-monitors 3.6.4-1+deb10

=== debian/changelog ===
hubzero-submit-monitors (3.6.4-1+deb10) unstable; urgency=low

    Update to version 3.6.4
    Added scripts for starting/stopping/reporting services status
    Switch to default sqlite job database

 -- Steven Clark <smclark@ucsd.edu>  Fri, 09 Jun 2023 07:51:22 -0700

## hubzero-submit-monitors 3.7.0-1+deb7

=== debian/changelog ===
hubzero-submit-monitors (3.7.0-1+deb7) unstable; urgency=low

    Removed deprecated function

 -- Steven Clark <smclark@ucsd.edu>  Thu, 18 May 2023 10:53:29 -0700

## hubzero-submit-monitors 3.7.0-1+deb10

=== Makefile ===
--- 
+++ 
@@ -50,7 +50,6 @@
                          personalize-copy-proxy.sh personalize-saml-proxy.sh \
                          refresh-condor-proxy.sh refresh-jobmon-proxy.sh \
                          refresh-oauth-token.sh writecommunitysecret.sh
-SERVICEMONITORS = start status stop
 SUBMITDIR=$(DESTDIR)/opt/submit
 VARLOGDIR=$(DESTDIR)/var/log
 VARGRIDMAN=$(DESTDIR)/var/gridman
@@ -95,10 +94,6 @@
 	# initialize-monitor-job
 	install --mode 0750 -D monitorJobInitialize.py $(SUBMITDIR)/monitorJobInitialize.py
 	install --mode 0750 -D monitorJobInitialize.sh $(SUBMITDIR)/monitorJobInitialize.sh
-	# install-process-monitors
-	for serviceMonitor in $(SERVICEMONITORS) ; do \
-		install --mode 0750 -D $${serviceMonitor} $(SUBMITDIR)/$${serviceMonitor}; \
-	done
 	# install-monitor-logs
 	install --mode 0775 -d $(VARLOGDIR)/submit
 	install --mode 0755 -d $(VARLOGDIR)/submit/monitors
@@ -147,10 +142,6 @@
 	for manageIdentityUtil in $(MANAGEIDENTITYUTILS) ; do \
 		chgrp gridman $(SUBMITDIR)/$(manageIdentityUtil); \
 	done
-	# install-process-monitors
-	for serviceMonitor in $(SERVICEMONITORS) ; do \
-		chgrp gridman $(SUBMITDIR)/$(serviceMonitor); \
-	done
 	# install-monitor-logs
 	if [ ! -d ${VARLOG}/submit ] ; \
 	then \

=== debian/changelog ===
hubzero-submit-monitors (3.7.0-1+deb10) unstable; urgency=low

    Removed deprecated function

 -- Steven Clark <smclark@ucsd.edu>  Thu, 18 May 2023 10:53:29 -0700

## hubzero-submit-monitors 3.7.1-1+deb7

=== debian/changelog ===
hubzero-submit-monitors (3.7.1-1+deb7) unstable; urgency=low

    - Upgrade to 3.7.1
    - Added scripts for starting/stopping/reporting services status
    - Switch to default sqlite job database

 -- Steven Clark <smclark@ucsd.edu>  Mon, 30 May 2023 07:45:05 -0700

hubzero-submit-monitors (3.7.0-1) unstable; urgency=low

    - Upgrade to 3.7.0
    - Removed deprecated function

 -- Steven Clark <smclark@ucsd.edu>  Thu, 18 May 2023 10:53:29 -0700

## hubzero-submit-monitors 3.7.1-1+deb10

=== debian/changelog ===
hubzero-submit-monitors (3.7.1-1+deb10) unstable; urgency=low

    - Upgrade to 3.7.1
    - Added scripts for starting/stopping/reporting services status
    - Switch to default sqlite job database

 -- Steven Clark <smclark@ucsd.edu>  Mon, 30 May 2023 07:45:05 -0700

## hubzero-submit-monitors 3.7.2-1+deb7

=== debian/changelog ===
hubzero-submit-monitors (3.7.2-1+deb7) unstable; urgency=low

    - Upgrade to 3.7.2

 -- Steven Clark <smclark@ucsd.edu>  Wed, 20 Dec 2023 06:58:13 -0800

hubzero-submit-monitors (3.7.1-1) unstable; urgency=low

    - Upgrade to 3.7.1
    - Added scripts for starting/stopping/reporting services status
    - Switch to default sqlite job database

 -- Steven Clark <smclark@ucsd.edu>  Mon, 30 May 2023 07:45:05 -0700

=== debian/rules ===
#!/usr/bin/make -f
#
# @package      hubzero-submit-monitors
# @file         rules
# @copyright    Copyright (c) 2010-2020 The Regents of the University of California.
# @license      http://opensource.org/licenses/MIT MIT
#
# Copyright (c) 2010-2020 The Regents of the University of California.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# HUBzero is a registered trademark of The Regents of the University of California.
#

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

$(info ########## Goals: $(MAKECMDGOALS) ##########)

CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

export CFLAGS
export CPPFLAGS
export CXXFLAGS
export LDFLAGS

DEB_MAJOR:=$(shell lsb_release -r -s | cut -d . -f 1)

configure:
	@echo "########## configure ##########"
	dh_testdir
	>$@

build: configure
	@echo "########## build ##########"
	dh_testdir
	$(MAKE)
	cp jobmon $(CURDIR)/debian/jobmon.init
	cp tunnelmon $(CURDIR)/debian/tunnelmon.init
	cp probemon $(CURDIR)/debian/probemon.init
	cp identityman $(CURDIR)/debian/identityman.init
	#>$@

clean:
	@echo "########## clean ##########"
	dh_testdir
	dh_testroot
	rm -fr build configure
	$(MAKE) clean
	rm -f $(CURDIR)/debian/jobmon.init
	rm -f $(CURDIR)/debian/tunnelmon.init
	rm -f $(CURDIR)/debian/probemon.init
	rm -f $(CURDIR)/debian/identityman.init
	dh_clean

install: build
	@echo "########## install ##########"
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) DESTDIR=$(CURDIR)/debian/hubzero-submit-monitors COMPILE=--no-compile install

binary-indep: install
	@echo "########## binary-indep ##########"
	dh_testdir -i
	dh_testroot -i
	dh_installchangelogs -i
	dh_installdocs -i
	dh_installexamples -i
	dh_install -i
	dh_installlogrotate -i
	dh_installinit -i --name=jobmon 
	dh_installinit -i --name=tunnelmon
	dh_installinit -i --name=probemon
	dh_installinit -i --name=identityman
	dh_installman -i
	dh_python2 -i
	dh_link -i
	dh_strip -i
	dh_lintian -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary-arch: install
	@echo "########## binary-arch ##########"
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs -a
	dh_installdocs -a
	dh_installexamples -a
	dh_install -a
	dh_installlogrotate -a
	dh_installinit -a
	dh_installman -a
	dh_link -a
	dh_strip -a
	dh_lintian -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep 
#binary: binary-arch
	@echo "########## binary ##########"

.PHONY: clean binary-indep binary-arch binary install

## hubzero-submit-monitors 3.7.2-1+deb10

=== debian/changelog ===
hubzero-submit-monitors (3.7.2-1+deb10) unstable; urgency=low

    - Upgrade to 3.7.2

 -- Steven Clark <smclark@ucsd.edu>  Wed, 20 Dec 2023 06:58:13 -0800

## hubzero-submit-monitors 3.8.1-1+deb7

=== debian/changelog ===
hubzero-submit-monitors (3.8.1-1+deb7) unstable; urgency=low

     - Fix status command accounting for multiple transient job monitor scripts running.
     - Update to version 3.8.1
     - Standardize writes to stdout/stderr with failure reported to log file.
     - Add TapisV3
     - Update read config files across the board to read dictionary
       values in JSON format
     - Preemptive change to strings containing deprecated backslash characters.
       In Python 3.12 the DeprecationWarning is upgraded to a SyntaxWarning.

 -- Steven Clark <smclark@ucsd.edu>  Thu, 26 Jun 2025 7:33:19 -0700

hubzero-submit-monitors (3.7.4-1) unstable; urgency=low

    - Upgrade to 3.7.4

 -- Steven Clark <smclark@ucsd.edu>  Tue, 14 Jan 2025 10:07:47 -0800

hubzero-submit-monitors (3.7.3.1-1) unstable; urgency=low

    -  fix creation of /var/run/submit to be tmpfs compatible

 -- Steven Clark <smclark@ucsd.edu>  Fri, 14 Jun 2024 15:49:33 -0700

hubzero-submit-monitors (3.7.3-1) unstable; urgency=low

    Upgrade to 3.7.3
    Support el8
    Usage instruction correction
    Bring daemon management scripts up to date
    Finally making switch from init.d to systemd
    Adding cloud source code - not used
    Added cloud monitor (it is not currently used)

 -- Steven Clark <smclark@ucsd.edu>  Thu, 13 Jun 2024 13:10:40 -0700

hubzero-submit-monitors (3.7.2-1) unstable; urgency=low

    - Upgrade to 3.7.2

 -- Steven Clark <smclark@ucsd.edu>  Wed, 20 Dec 2023 06:58:13 -0800

## hubzero-submit-monitors 3.8.1-1+deb10

=== debian/changelog ===
hubzero-submit-monitors (3.8.1-1+deb10) unstable; urgency=low

     - Fix status command accounting for multiple transient job monitor scripts running.
     - Update to version 3.8.1
     - Standardize writes to stdout/stderr with failure reported to log file.
     - Add TapisV3
     - Update read config files across the board to read dictionary
       values in JSON format
     - Preemptive change to strings containing deprecated backslash characters.
       In Python 3.12 the DeprecationWarning is upgraded to a SyntaxWarning.

 -- Steven Clark <smclark@ucsd.edu>  Thu, 26 Jun 2025 7:33:19 -0700

## hubzero-submit-monitors 3.8.2-1+deb7

=== debian/changelog ===
hubzero-submit-monitors (3.8.2-1+deb7) unstable; urgency=low

     - Refresh tokens for both Tapis2 and Tapis3
     - Updated for change in condor.pid location

 -- Steven Clark <clarksm@purdue.edu>  Fri, 31 Oct 2025 8:35:44 -0400

hubzero-submit-monitors (3.8.1-1) unstable; urgency=low

     - Fix status command accounting for multiple transient job monitor scripts running.
     - Update to version 3.8.1
     - Standardize writes to stdout/stderr with failure reported to log file.
     - Add TapisV3
     - Update read config files across the board to read dictionary
       values in JSON format
     - Preemptive change to strings containing deprecated backslash characters.
       In Python 3.12 the DeprecationWarning is upgraded to a SyntaxWarning.

 -- Steven Clark <smclark@ucsd.edu>  Thu, 26 Jun 2025 7:33:19 -0700

=== debian/control ===
Source: hubzero-submit-monitors
Section: misc
Priority: optional
Maintainer: Nicholas J. Kisseberth <nkisseberth@ucsd.edu>
Build-Depends: debhelper (>= 8.0.0),  , python-all,python-support   
Standards-Version: 3.8.4
X-Python-Version: >= 2.6
Homepage: http://hubzero.org

Package: hubzero-submit-monitors
Architecture: all
Depends: adduser, hubzero-use, hubzero-use-apps, bind9-host,openssh-client, python (>=2.6), ${misc:Depends}
Recommends: hubzero-submit-distributor, hubzero-submit-server
Description: HUBzero submit monitors
 HUBzero submit monitor services

## hubzero-submit-monitors 3.8.2-1+deb10

=== debian/changelog ===
hubzero-submit-monitors (3.8.2-1+deb10) unstable; urgency=low

     - Refresh tokens for both Tapis2 and Tapis3
     - Updated for change in condor.pid location

 -- Steven Clark <clarksm@purdue.edu>  Fri, 31 Oct 2025 8:35:44 -0400

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: misc
 Priority: optional
 Maintainer: Nicholas J. Kisseberth <nkisseberth@ucsd.edu>
-Build-Depends: debhelper (>= 8.0.0),  , python-all,python-support   
+Build-Depends: debhelper (>= 8.0.0),     
 Standards-Version: 3.8.4
 X-Python-Version: >= 2.6
 Homepage: http://hubzero.org

=== debian/rules ===
--- 
+++ 
@@ -94,7 +94,7 @@
 	dh_installinit -i --name=probemon
 	dh_installinit -i --name=identityman
 	dh_installman -i
-	dh_python2 -i
+	if [ -f /usr/bin/python2 ]; then dh_python2 -i; fi
 	dh_link -i
 	dh_strip -i
 	dh_lintian -i

## hubzero-submit-monitors 3.8.2-1+deb12

=== debian/changelog ===
hubzero-submit-monitors (3.8.2-1+deb12) unstable; urgency=low

     - Refresh tokens for both Tapis2 and Tapis3
     - Updated for change in condor.pid location

 -- Steven Clark <clarksm@purdue.edu>  Fri, 31 Oct 2025 8:35:44 -0400

## hubzero-submit-monitors 3.9.1-1+deb7

=== debian/changelog ===
hubzero-submit-monitors (3.9.1-1+deb7) unstable; urgency=low

    - Upgrade to 3.9.1

 -- Steven Clark <clarksm@purdue.edu>  Thu, 13 Nov 2025 14:14:50 -0400

hubzero-submit-monitors (3.8.2-1) unstable; urgency=low

     - Refresh tokens for both Tapis2 and Tapis3
     - Updated for change in condor.pid location

 -- Steven Clark <clarksm@purdue.edu>  Fri, 31 Oct 2025 8:35:44 -0400

## hubzero-submit-monitors 3.9.1-1+deb10

=== debian/changelog ===
hubzero-submit-monitors (3.9.1-1+deb10) unstable; urgency=low

    - Upgrade to 3.9.1

 -- Steven Clark <clarksm@purdue.edu>  Thu, 13 Nov 2025 14:14:50 -0400

## hubzero-submit-monitors 3.9.1-1+deb12

=== debian/changelog ===
hubzero-submit-monitors (3.9.1-1+deb12) unstable; urgency=low

    - Upgrade to 3.9.1

 -- Steven Clark <clarksm@purdue.edu>  Thu, 13 Nov 2025 14:14:50 -0400

## hubzero-submit-monitors 3.9.1.1-1+deb7

=== Makefile ===
--- 
+++ 
@@ -50,10 +50,13 @@
                          personalize-copy-proxy.sh personalize-saml-proxy.sh \
                          refresh-condor-proxy.sh refresh-jobmon-proxy.sh \
                          refresh-oauth-token.sh writecommunitysecret.sh
+SERVICEMONITORS = start status stop
 SUBMITDIR=$(DESTDIR)/opt/submit
 VARLOGDIR=$(DESTDIR)/var/log
 VARGRIDMAN=$(DESTDIR)/var/gridman
 ETCDIR=$(DESTDIR)/etc
+USRDIR=$(DESTDIR)/usr
+USRLIB=$(DESTDIR)/usr/lib
 
 all:
 	@true
@@ -94,29 +97,42 @@
 	# initialize-monitor-job
 	install --mode 0750 -D monitorJobInitialize.py $(SUBMITDIR)/monitorJobInitialize.py
 	install --mode 0750 -D monitorJobInitialize.sh $(SUBMITDIR)/monitorJobInitialize.sh
+	# install-process-monitors
+	for serviceMonitor in $(SERVICEMONITORS) ; do \
+		install --mode 0750 -D $${serviceMonitor} $(SUBMITDIR)/$${serviceMonitor}; \
+	done
 	# install-monitor-logs
 	install --mode 0775 -d $(VARLOGDIR)/submit
 	install --mode 0755 -d $(VARLOGDIR)/submit/monitors
 	# install-server-init
 	[ -f $(ETCDIR)/submit/jobmonitors.conf ] || install --mode 0644 -D jobmonitor.conf_dft $(ETCDIR)/submit/jobmonitor.conf
-	install --mode 0755 -D identityman $(ETCDIR)/init.d/identityman
-	install --mode 0755 -D jobcachesimtools $(ETCDIR)/init.d/jobcachesimtools
-	install --mode 0755 -D jobexe $(ETCDIR)/init.d/jobexe
-	install --mode 0755 -D jobmetrics $(ETCDIR)/init.d/jobmetrics 
-	install --mode 0755 -D jobmon $(ETCDIR)/init.d/jobmon  
-	install --mode 0755 -D jobpro $(ETCDIR)/init.d/jobpro
-	install --mode 0755 -D jobstageinput $(ETCDIR)/init.d/jobstageinput
-	install --mode 0755 -D tunnelmon $(ETCDIR)/init.d/tunnelmon 
-	install --mode 0755 -D probemon $(ETCDIR)/init.d/probemon 
+	install --mode 0755 -d $(SUBMITDIR)/systemd
+	install --mode 0640 -D cloudmon.service         $(USRLIB)/systemd/system/cloudmon.service
+	install --mode 0640 -D identityman.service      $(USRLIB)/systemd/system/identityman.service
+	install --mode 0640 -D jobcachesimtools.service $(USRLIB)/systemd/system/jobcachesimtools.service
+	install --mode 0640 -D jobexe.service           $(USRLIB)/systemd/system/jobexe.service
+	install --mode 0640 -D jobmetrics.service       $(USRLIB)/systemd/system/jobmetrics.service
+	install --mode 0640 -D jobmon-sqlite.service    $(USRLIB)/systemd/system/jobmon.service
+	install --mode 0640 -D jobpro.service           $(USRLIB)/systemd/system/jobpro.service
+	install --mode 0640 -D jobstageinput.service    $(USRLIB)/systemd/system/jobstageinput.service
+	install --mode 0640 -D probemon.service         $(USRLIB)/systemd/system/probemon.service
+	install --mode 0640 -D tunnelmon.service        $(USRLIB)/systemd/system/tunnelmon.service
+	install --mode 0640 -D jobmon-sql.service       $(SUBMITDIR)/systemd/jobmon.service
 	python3 setup.py install $(COMPILE) --root $(DESTDIR) $(il)
 
 uninstall:
-	@true
+	rm -f $(USRLIB)/systemd/system/cloudmon.service $(USRLIB)/systemd/system/identityman.service \
+         $(USRLIB)/systemd/system/jobcachesimtools.service $(USRLIB)/systemd/system/jobexe.service \
+         $(USRLIB)/systemd/system/jobmetrics.service $(USRLIB)/systemd/system/jobmon.service \
+         $(USRLIB)/systemd/system/jobpro.service $(USRLIB)/systemd/system/jobstageinput.service \
+         $(USRLIB)/systemd/system/probemon.service $(USRLIB)/systemd/system/tunnelmon.service \
+	      $(SUBMITDIR)/systemd/jobmon.service
 
 postinst:
 	# install-user-gridman
 	adduser --quiet --system --group --force-badname --home /var/gridman --shell /bin/bash --disabled-password --gecos Gridman gridman || true
 	adduser --quiet gridman tunneler || true
+
 	# install-monitor-job
 	chgrp gridman $(SUBMITDIR)/monitorJobInitialize.py
 	chgrp gridman $(SUBMITDIR)/monitorJobInitialize.sh
@@ -142,6 +158,10 @@
 	for manageIdentityUtil in $(MANAGEIDENTITYUTILS) ; do \
 		chgrp gridman $(SUBMITDIR)/$(manageIdentityUtil); \
 	done
+	# install-process-monitors
+	for serviceMonitor in $(SERVICEMONITORS) ; do \
+		chgrp gridman $(SUBMITDIR)/$(serviceMonitor); \
+	done
 	# install-monitor-logs
 	if [ ! -d ${VARLOG}/submit ] ; \
 	then \
@@ -218,16 +238,12 @@
 	$(SUBMITDIR)/monitorJobInitialize.sh
 
 	# install-server-init
-	insserv probemon
-	insserv identityman
-	insserv jobcachesimtools
-	insserv jobexe
-	insserv jobmetrics 
-	insserv jobmon  
-	insserv jobpro
-	insserv jobstageinput
-	insserv tunnelmon
-	insserv
+	rm -f $(ETCDIR)/init.d/identityman $(ETCDIR)/init.d/jobcachesimtools \
+         $(ETCDIR)/init.d/jobexe $(ETCDIR)/init.d/jobmetrics \
+         $(ETCDIR)/init.d/jobmon  $(ETCDIR)/init.d/jobpro \
+         $(ETCDIR)/init.d/jobstageinput $(ETCDIR)/init.d/tunnelmon \
+         $(ETCDIR)/init.d/probemon $(ETCDIR)/init.d/cloudmon
+	systmctl daemon-reload
 
 clean:
 	find . -name '*.pyc' -delete

=== debian/changelog ===
hubzero-submit-monitors (3.9.1.1-1+deb7) unstable; urgency=low

    - Ignore empty jobIds

 -- Steven Clark <clarksm@purdue.edu>  Thu, 20 Nov 2025 10:30:10 -0400

hubzero-submit-monitors (3.9.1-1) unstable; urgency=low

    - Upgrade to 3.9.1

 -- Steven Clark <clarksm@purdue.edu>  Thu, 13 Nov 2025 14:14:50 -0400

## hubzero-submit-monitors 3.9.1.1-1+deb10

=== debian/changelog ===
hubzero-submit-monitors (3.9.1.1-1+deb10) unstable; urgency=low

    - Ignore empty jobIds

 -- Steven Clark <clarksm@purdue.edu>  Thu, 20 Nov 2025 10:30:10 -0400

## hubzero-submit-monitors 3.9.1.1-1+deb12

=== debian/changelog ===
hubzero-submit-monitors (3.9.1.1-1+deb12) unstable; urgency=low

    - Ignore empty jobIds

 -- Steven Clark <clarksm@purdue.edu>  Thu, 20 Nov 2025 10:30:10 -0400

## hubzero-submit-monitors 3.10.1-1+deb7

=== debian/changelog ===
hubzero-submit-monitors (3.10.1-1+deb7) unstable; urgency=low

     - Moved IdentitiesManager.py from distributor to monitors
     - Consolidate openLogger(), daemonize(), and writePIDFile() functions.
     - Set log level, log file, configuration file, through use of environment variables.
       The environment variables can be set in the unit service files.  This allows the same
       base to be used for multiple services.  Immediate use if for configuration of
       local only or restricted submit server.

 -- Steven Clark <clarksm@purdue.edu>  Wed,  10 Dec 2025 11:56:33 -0400

hubzero-submit-monitors (3.9.1.1-1) unstable; urgency=low

    - Ignore empty jobIds

 -- Steven Clark <clarksm@purdue.edu>  Thu, 20 Nov 2025 10:30:10 -0400

## hubzero-submit-monitors 3.10.1-1+deb10

=== debian/changelog ===
hubzero-submit-monitors (3.10.1-1+deb10) unstable; urgency=low

     - Moved IdentitiesManager.py from distributor to monitors
     - Consolidate openLogger(), daemonize(), and writePIDFile() functions.
     - Set log level, log file, configuration file, through use of environment variables.
       The environment variables can be set in the unit service files.  This allows the same
       base to be used for multiple services.  Immediate use if for configuration of
       local only or restricted submit server.

 -- Steven Clark <clarksm@purdue.edu>  Wed,  10 Dec 2025 11:56:33 -0400

## hubzero-submit-monitors 3.10.1-1+deb12

=== debian/changelog ===
hubzero-submit-monitors (3.10.1-1+deb12) unstable; urgency=low

     - Moved IdentitiesManager.py from distributor to monitors
     - Consolidate openLogger(), daemonize(), and writePIDFile() functions.
     - Set log level, log file, configuration file, through use of environment variables.
       The environment variables can be set in the unit service files.  This allows the same
       base to be used for multiple services.  Immediate use if for configuration of
       local only or restricted submit server.

 -- Steven Clark <clarksm@purdue.edu>  Wed,  10 Dec 2025 11:56:33 -0400

## hubzero-submit-monitors 3.11.1-1+deb7

=== debian/changelog ===
hubzero-submit-monitors (3.11.1-1+deb7) unstable; urgency=low

     - Return updated job status immediately after new submission
     - Relax permissions on BatchMonitors to allow visibility for non root users
     - Move systemd unit files to separate directory
     - Change from polling to notification alerts for updaing WS job status
     - Add more job count reporting at startup
     - split jobmonitor.conf into two parts for monitorjob and monitorjobsite
     - Run all daemon logging through rsyslog
     - Change from polling to notification alerts for updaing WS job status
     - Make way for systemd replacement for init.d

 -- Steven Clark <clarksm@purdue.edu>  Fri, 13 Feb 2026 11:53:33 -0400

hubzero-submit-monitors (3.10.1-1) unstable; urgency=low

     - Moved IdentitiesManager.py from distributor to monitors
     - Consolidate openLogger(), daemonize(), and writePIDFile() functions.
     - Set log level, log file, configuration file, through use of environment variables.
       The environment variables can be set in the unit service files.  This allows the same
       base to be used for multiple services.  Immediate use if for configuration of
       local only or restricted submit server.

 -- Steven Clark <clarksm@purdue.edu>  Wed,  10 Dec 2025 11:56:33 -0400

## hubzero-submit-monitors 3.11.1-1+deb10

=== debian/changelog ===
hubzero-submit-monitors (3.11.1-1+deb10) unstable; urgency=low

     - Return updated job status immediately after new submission
     - Relax permissions on BatchMonitors to allow visibility for non root users
     - Move systemd unit files to separate directory
     - Change from polling to notification alerts for updaing WS job status
     - Add more job count reporting at startup
     - split jobmonitor.conf into two parts for monitorjob and monitorjobsite
     - Run all daemon logging through rsyslog
     - Change from polling to notification alerts for updaing WS job status
     - Make way for systemd replacement for init.d

 -- Steven Clark <clarksm@purdue.edu>  Fri, 13 Feb 2026 11:53:33 -0400

## hubzero-submit-monitors 3.11.1-1+deb12

=== Makefile ===
--- 
+++ 
@@ -33,7 +33,7 @@
 il=--install-layout=deb
 endif
 
-BATCHMONITORS = monitorBOINC.py monitorCondor.py monitorCondorG.py monitorFactory.py monitorLL.py \
+BATCHMONITORS = monitorBOINC.py monitorCondor.py monitorFactory.py monitorLL.py \
                 monitorLSF.py monitorPBS.py monitorSGE.py monitorSLURM.py monitorWF.py
 MONITORJOBS = monitorJob.py monitorJobSite.py monitorJobSQL.py monitorJobSiteSQL.py \
               jobCacheSimTools.py jobExecuter.py jobMetrics.py jobProcessor.py jobStageInput.py
@@ -65,10 +65,11 @@
 	# create-optsubmit
 	install --mode 0755 -d $(SUBMITDIR)
 	# install-batchmonitors
-	install --mode 2750 -d $(SUBMITDIR)/BatchMonitors
+	install --mode 2751 -d $(SUBMITDIR)/BatchMonitors
 	for batchMonitor in $(BATCHMONITORS) ; do \
-		install --mode 0750 -D BatchMonitors/$${batchMonitor} $(SUBMITDIR)/BatchMonitors/$${batchMonitor}; \
-	done
+		install --mode 0755 -D BatchMonitors/$${batchMonitor} $(SUBMITDIR)/BatchMonitors/$${batchMonitor}; \
+	done
+	rm -f $(SUBMITDIR)/BatchMonitors/monitorCondorG.py
 	# install-monitor-job
 	for monitorJob in $(MONITORJOBS) ; do \
 		install --mode 0750 -D $${monitorJob} $(SUBMITDIR)/$${monitorJob}; \
@@ -107,26 +108,26 @@
 	# install-server-init
 	[ -f $(ETCDIR)/submit/jobmonitors.conf ] || install --mode 0644 -D jobmonitor.conf_dft $(ETCDIR)/submit/jobmonitor.conf
 	install --mode 0755 -d $(SUBMITDIR)/systemd
-	install --mode 0640 -D cloudmon.service         $(USRLIB)/systemd/system/cloudmon.service
-	install --mode 0640 -D identityman.service      $(USRLIB)/systemd/system/identityman.service
-	install --mode 0640 -D jobcachesimtools.service $(USRLIB)/systemd/system/jobcachesimtools.service
-	install --mode 0640 -D jobexe.service           $(USRLIB)/systemd/system/jobexe.service
-	install --mode 0640 -D jobmetrics.service       $(USRLIB)/systemd/system/jobmetrics.service
-	install --mode 0640 -D jobmon-sqlite.service    $(USRLIB)/systemd/system/jobmon.service
-	install --mode 0640 -D jobpro.service           $(USRLIB)/systemd/system/jobpro.service
-	install --mode 0640 -D jobstageinput.service    $(USRLIB)/systemd/system/jobstageinput.service
-	install --mode 0640 -D probemon.service         $(USRLIB)/systemd/system/probemon.service
-	install --mode 0640 -D tunnelmon.service        $(USRLIB)/systemd/system/tunnelmon.service
-	install --mode 0640 -D jobmon-sql.service       $(SUBMITDIR)/systemd/jobmon.service
+	install --mode 0640 -D systemd/cloudmon.service         $(USRLIB)/systemd/system/cloudmon.service
+	install --mode 0640 -D systemd/identityman.service      $(USRLIB)/systemd/system/identityman.service
+	install --mode 0640 -D systemd/jobcachesimtools.service $(USRLIB)/systemd/system/jobcachesimtools.service
+	install --mode 0640 -D systemd/jobexe.service           $(USRLIB)/systemd/system/jobexe.service
+	install --mode 0640 -D systemd/jobmetrics.service       $(USRLIB)/systemd/system/jobmetrics.service
+	install --mode 0640 -D systemd/jobmon-sqlite.service    $(USRLIB)/systemd/system/jobmon.service
+	install --mode 0640 -D systemd/jobpro.service           $(USRLIB)/systemd/system/jobpro.service
+	install --mode 0640 -D systemd/jobstageinput.service    $(USRLIB)/systemd/system/jobstageinput.service
+	install --mode 0640 -D systemd/probemon.service         $(USRLIB)/systemd/system/probemon.service
+	install --mode 0640 -D systemd/tunnelmon.service        $(USRLIB)/systemd/system/tunnelmon.service
+	install --mode 0640 -D systemd/jobmon-sql.service       $(SUBMITDIR)/systemd/jobmon.service
 	python3 setup.py install $(COMPILE) --root $(DESTDIR) $(il)
 
 uninstall:
 	rm -f $(USRLIB)/systemd/system/cloudmon.service $(USRLIB)/systemd/system/identityman.service \
-         $(USRLIB)/systemd/system/jobcachesimtools.service $(USRLIB)/systemd/system/jobexe.service \
-         $(USRLIB)/systemd/system/jobmetrics.service $(USRLIB)/systemd/system/jobmon.service \
-         $(USRLIB)/systemd/system/jobpro.service $(USRLIB)/systemd/system/jobstageinput.service \
-         $(USRLIB)/systemd/system/probemon.service $(USRLIB)/systemd/system/tunnelmon.service \
-	      $(SUBMITDIR)/systemd/jobmon.service
+              $(USRLIB)/systemd/system/jobcachesimtools.service $(USRLIB)/systemd/system/jobexe.service \
+              $(USRLIB)/systemd/system/jobmetrics.service $(USRLIB)/systemd/system/jobmon.service \
+              $(USRLIB)/systemd/system/jobpro.service $(USRLIB)/systemd/system/jobstageinput.service \
+              $(USRLIB)/systemd/system/probemon.service $(USRLIB)/systemd/system/tunnelmon.service \
+              $(SUBMITDIR)/systemd/jobmon.service
 
 postinst:
 	# install-user-gridman

=== debian/changelog ===
hubzero-submit-monitors (3.11.1-1+deb12) unstable; urgency=low

     - Return updated job status immediately after new submission
     - Relax permissions on BatchMonitors to allow visibility for non root users
     - Move systemd unit files to separate directory
     - Change from polling to notification alerts for updaing WS job status
     - Add more job count reporting at startup
     - split jobmonitor.conf into two parts for monitorjob and monitorjobsite
     - Run all daemon logging through rsyslog
     - Change from polling to notification alerts for updaing WS job status
     - Make way for systemd replacement for init.d

 -- Steven Clark <clarksm@purdue.edu>  Fri, 13 Feb 2026 11:53:33 -0400

=== debian/rules ===
--- 
+++ 
@@ -54,10 +54,10 @@
 	@echo "########## build ##########"
 	dh_testdir
 	$(MAKE)
-	cp jobmon $(CURDIR)/debian/jobmon.init
-	cp tunnelmon $(CURDIR)/debian/tunnelmon.init
-	cp probemon $(CURDIR)/debian/probemon.init
-	cp identityman $(CURDIR)/debian/identityman.init
+	cp init.d/jobmon $(CURDIR)/debian/jobmon.init
+	cp init.d/tunnelmon $(CURDIR)/debian/tunnelmon.init
+	cp init.d/probemon $(CURDIR)/debian/probemon.init
+	cp init.d/identityman $(CURDIR)/debian/identityman.init
 	#>$@
 
 clean:
